# frozen_string_literal: true

require 'facter'

module Cfgd
  class Adapter
    # a basic abstract initsystem class
    class AbstractInitsystem
      def self.descendants
        ObjectSpace.each_object(Class).select { |klass| klass < self }
      end
    end

    # a basic class to choose the right adapter
    class Initsystem < AbstractInitsystem
      def self.adapters
        AbstractInitsystem.descendants - [self]
      end

      def self.adapter
        @adapter ||= adapters.find { |adapter| adapter.supports_os? Facter['osfamily'].value.downcase }
      end
    end
  end
end
require_relative './initsystem/systemd'
require_relative './initsystem/sysvinit'
