# frozen_string_literal: true

require 'facter'

module Cfgd
  class Adapter
    # a basic abstract package manager class
    class AbstractPkgmanager
      def self.descendants
        ObjectSpace.each_object(Class).select { |klass| klass < self }
      end
    end

    # a basic class to choose the right adapter
    class Pkgmanager < AbstractPkgmanager
      def self.adapters
        AbstractPkgmanager.descendants - [self]
      end

      def self.adapter
        @adapter ||= adapters.find { |adapter| adapter.supports_os? Facter['osfamily'].value.downcase }
      end
    end
  end
end
require_relative './pkgmanager/pkg'
require_relative './pkgmanager/apt'
require_relative './pkgmanager/pacman'
