# frozen_string_literal: true

module Cfgd
  # defines guideline
  class Guide
    attr_accessor :name
    def self.descendants
      ObjectSpace.each_object(Class).select { |klass| klass < self }
    end

    def initialize(name:)
      @name = name
    end

    def self.debug(message)
      warn "Debug: #{message}"
      # File.write('/tmp/cfgd.log', message, mode: 'a')
    end
  end
end
