# frozen_string_literal: true

require_relative '../adapter/pkgmanager.rb'

module Cfgd
  # provides some basic Service operations. Will work with sysv and systemd
  class Package < Guide
    # self.install
    # parent method for installing packages. Give single package name or an array of packages
    #
    def self.install(args)
      @adapter = Cfgd::Adapter::Pkgmanager.adapter
      if args.class.eql? Array
        args.each do |pkgname|
          debug "#{name}.#{__method__} => #{pkgname}"
          @adapter.install_single(pkgname)
        end
      elsif name.class.eql? String
        debug "#{name}.#{__method__} => #{args}"
        @adapter.install_single(args)
      else
        raise ArgumentError, 'Give Array or String'
      end
    end

    def self.installed?(args)
      @adapter = Cfgd::Adapter::Pkgmanager.adapter
      debug "#{name}.#{__method__} => #{args}"
      @adapter.installed?(args)
    end

    def self.remove(args)
      @adapter = Cfgd::Adapter::Pkgmanager.adapter
      if args.class.eql? Array
        args.each do |pkgname|
          debug "#{name}.#{__method__} => #{pkgname}"
          @adapter.remove_single(pkgname)
        end
      elsif name.class.eql? String
        debug "#{name}.#{__method__} => #{args}"
        @adapter.remove_single(args)
      else
        raise ArgumentError, 'Give Array or String'
      end
    end
  end
end
