# frozen_string_literal: true

require 'facter'
require_relative './exceptions'
require_relative '../adapter/initsystem'

module Cfgd
  # provides some basic Service operations. Will work with sysv and systemd
  class Service < Guide
    # self.stop
    # parent method for stopping services
    #
    def self.stop(servicename)
      @adapter = Cfgd::Adapter::Initsystem.adapter
      debug "#{name}.#{__method__} => #{servicename}"
      @adapter.stop servicename
    end

    # self.start
    # parent method for starting services
    #
    def self.start(servicename)
      @adapter = Cfgd::Adapter::Initsystem.adapter
      debug "#{name}.#{__method__} => #{servicename}"
      @adapter.start servicename
    end

    # self.status
    # parent method for gettig the status of the service (as bool)
    #
    def self.status(servicename)
      @adapter = Cfgd::Adapter::Initsystem.adapter
      debug "#{name}.#{__method__} => #{servicename}"
      @adapter.status servicename
    end
  end
end
